package setpersist.entity;

import java.io.Serializable;
import java.util.Objects;
import javax.persistence.*;

@Entity
public class Agreement  implements Serializable{

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.TABLE, generator = "GEE1AGREEMENT_GENERATOR")
    @TableGenerator(name = "GEE1AGREEMENT_GENERATOR")
    private Long id;

    // Unidirectional
    @ManyToOne
    @JoinColumn(nullable = false)
    private Person buyer;

    // Unidirectional
    @ManyToOne
    @JoinColumn(nullable = false)
    private Person seller;

    // Bidirectional
    @ManyToOne(optional = true)
    private Shipment shipment;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Person getBuyer() {
        return buyer;
    }

    public void setBuyer(Person buyer) {
        this.buyer = buyer;
    }

    public Person getSeller() {
        return seller;
    }

    public void setSeller(Person seller) {
        this.seller = seller;
    }

    public Shipment getShipment() {
        return shipment;
    }

    public void setShipment(Shipment shipment) {
        this.shipment = shipment;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 53 * hash + Objects.hashCode(this.id);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Agreement other = (Agreement) obj;
        if (!Objects.equals(this.id, other.id)) {
            return false;
        }
        return true;
    }

}
