//package setpersist.entity;

import java.util.Date;
import java.util.Set;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.TableGenerator;
import javax.persistence.Temporal;
import setpersist.entity.Person;
import setpersist.entity.Shipment;

/**
 *
 * @author name
 */
@Entity
public class Gee1Leg {

    @Id
    @GeneratedValue(strategy = GenerationType.TABLE, generator = "GEE1LEG_GENERATOR")
    @TableGenerator(name = "GEE1LEG_GENERATOR")
    private Long id;
    @ManyToOne
    @JoinColumn(nullable = false)
    private Shipment shipment;
    // legNumber in ascending order identifies leg within shipment.
    // However not an ID in database context - do not use for retrieval!
    private int legNumber;
    @ManyToMany
    // Without @JoinTable, JPA generates foreign key name gee1agreements_id in table
    // Gee1Leg_Gee1Agreement, so this must be overridden if not desired
    @JoinTable(
            inverseJoinColumns =
            @JoinColumn(name = "buyer_id"))
    // Set not List to avoid adding the same buyer multiple times.
    private Set<Person> buyers;
    /**
     * The end values are mostly duplicated because they are start values of the
     * next leg.
     */

    public Gee1Leg() {
    }

    public Gee1Leg(Shipment shipment, int legNumber, Set<Person> buyers) {
        this.shipment = shipment;
        this.legNumber = legNumber;
        this.buyers = buyers;
    }

    public Shipment getShipment() {
        return shipment;
    }

    public void setShipment(Shipment shipment) {
        this.shipment = shipment;
    }

    public int getLegNumber() {
        return legNumber;
    }

    public void setLegNumber(int legNumber) {
        this.legNumber = legNumber;
    }

    public Set<Person> getBuyers() {
        return buyers;
    }

    public void setBuyers(Set<Person> buyers) {
        this.buyers = buyers;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Gee1Leg)) {
            return false;
        }
        Gee1Leg other = (Gee1Leg) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "ejb.entity.Gee1Leg[ id=" + id + " ]";
    }
}
